VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "richtx32.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7110
   ClientLeft      =   11295
   ClientTop       =   4275
   ClientWidth     =   5610
   LinkTopic       =   "Form1"
   ScaleHeight     =   7110
   ScaleWidth      =   5610
   Begin RichTextLib.RichTextBox RTB 
      Height          =   5175
      Index           =   1
      Left            =   480
      TabIndex        =   1
      Top             =   600
      Width           =   5175
      _ExtentX        =   9128
      _ExtentY        =   9128
      _Version        =   393217
      TextRTF         =   $"Form1.frx":0000
   End
   Begin RichTextLib.RichTextBox RTB 
      Height          =   5172
      Index           =   0
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   5172
      _ExtentX        =   9128
      _ExtentY        =   9128
      _Version        =   393217
      TextRTF         =   $"Form1.frx":008B
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" ( _
    ByVal hwnd As Long, _
    ByVal wMsg As Long, _
    ByVal wParam As Long, _
    lParam As Any _
) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    Destination As Any, _
    Source As Any, _
    ByVal Length As Long _
)

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" ( _
    ByVal hwnd As Long, _
    ByVal lpOperation As String, _
    ByVal lpFile As String, _
    ByVal lpParameters As String, _
    ByVal lpDirectory As String, _
    ByVal nShowCmd As Long _
) As Long


Private Const WM_USER = &H400
Private Const EM_AUTOURLDETECT = (WM_USER + 91)
Private Const EM_SETEVENTMASK = (WM_USER + 69)
Private Const WM_NOTIFY = &H4E
Private Const EN_LINK = &H70B
Private Const ENM_LINK = &H4000000
Private Const WM_LBUTTONUP = &H202
Private Const SW_SHOWNORMAL As Long = 1

Private WithEvents FormSubClass As clsSubClass
Attribute FormSubClass.VB_VarHelpID = -1

Private Type CharRange
  cpMin As Long     ' First character of range (0 for start of doc)
  cpMax As Long     ' Last character of range (-1 for end of doc)
End Type

Private Type nmhdr
    hwndFrom As Long
    idfrom As Long
    code As Long
End Type

Private Type ENLINK
    nmhdr As nmhdr
    Msg As Long
    wParam As Long
    lParam As Long
    chrg As CharRange
End Type

Private Const LF_FACESIZE = 32
Private Type CHARFORMAT2
    cbSize As Long
    dwMask As Long
    dwEffects As Long
    yHeight As Long
    yOffset As Long
    crTextColor As Long
    bCharSet As Byte
    bPitchAndFamily As Byte
    szFaceName(LF_FACESIZE - 1) As Byte
    wWeight As Integer
    sSpacing As Integer
    crBackColor As Long
    lcid As Long
    dwReserved As Long
    sStyle As Integer
    wKerning As Integer
    bUnderlineType As Byte
    bAnimation As Byte
    bRevAuthor As Byte
    bReserved1 As Byte
End Type

Public Sub EnableAutoURLDetection(lRTB As RichTextBox, INdex As Integer)

    'enable auto URL detection
    SendMessage lRTB.hwnd, EM_AUTOURLDETECT, 1&, ByVal 0&

    'subclass the parent of the RTB to receive EN_LINK notifications
    Set FormSubClass = New clsSubClass
    FormSubClass.INdex = INdex
    FormSubClass.Enable lRTB.Parent.hwnd
    
    'set RTB to notify parent when user has clicked hyperlink
    SendMessage lRTB.hwnd, EM_SETEVENTMASK, 0&, ByVal ENM_LINK

End Sub

Private Sub Form_Load()
    EnableAutoURLDetection RTB(0), 0
    EnableAutoURLDetection RTB(1), 1
End Sub

Private Sub FormSubClass_WMArrival(INdex As Integer, hwnd As Long, uMsg As Long, wParam As Long, lParam As Long, lRetVal As Long)
Dim notifyCode As nmhdr
Dim LinkData As ENLINK
Dim URL As String

    Select Case uMsg
    Case WM_NOTIFY

        CopyMemory notifyCode, ByVal lParam, LenB(notifyCode)
        If notifyCode.code = EN_LINK Then
        'A RTB sends EN_LINK notifications when it receives certain mouse messages
        'while the mouse pointer is over text that has the CFE_LINK effect:
        
        'To receive EN_LINK notifications, specify the ENM_LINK flag in the mask
        'sent with the EM_SETEVENTMASK message.
        
        'If you send the EM_AUTOURLDETECT message to enable automatic URL detection,
        'the RTB automatically sets the CFE_LINK effect for modified text that it
        'identifies as a URL.
        
            CopyMemory LinkData, ByVal lParam, Len(LinkData)
            If LinkData.Msg = WM_LBUTTONUP Then
                'user clicked on a hyperlink
                'get text with CFE_LINK effect that caused message to be sent
                URL = Mid(RTB(INdex).Text, LinkData.chrg.cpMin + 1, LinkData.chrg.cpMax - LinkData.chrg.cpMin)
                'launch the browser here
                ShellExecute 0&, "OPEN", URL, vbNullString, "C:\", SW_SHOWNORMAL
            End If

        End If
        lRetVal = FormSubClass.callWindProc(hwnd, uMsg, wParam, lParam)
        
    Case Else
        lRetVal = FormSubClass.callWindProc(hwnd, uMsg, wParam, lParam)
    End Select


End Sub


